<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Chat-boltalka
| spiker (autor Ryan Smith)
| http://www.sib-fusion.ru
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
----------------------------------------------------------+
|This is the PHP backend file for the AJAX Driven Chat application.
|You may use this code in your own projects as long as this copyright is left
|in place.  All code is provided AS-IS.
|This code is distributed in the hope that it will be useful,
|but WITHOUT ANY WARRANTY; without even the implied warranty of
|MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
|For the rest of the code visit http://www.DynamicAJAX.com
|Copyright 2005 Ryan Smith / 345 Technical / 345 Group.
+--------------------------------------------------------*/

//Send some headers to keep the user's browser from caching the response.
require_once "../../maincore.php";
include INFUSIONS."chat/db_include.php";
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT" ); 
header("Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . "GMT" ); 
header("Cache-Control: no-cache, must-revalidate" ); 
header("Pragma: no-cache" );
header("Content-Type: text/xml; charset=utf-8");

function bigword($string)
{
    $array_words=explode(' ', $string);
    $array_words_count=count($array_words);
    $string=null;
    for($i=0; $i<$array_words_count; $i++)
    {
        $word=$array_words[$i];
        if(strlen($word)>40) $word=chunk_split($word, 40, '\r\n');
        $string.=$word.' ';
    }
    $string=rtrim($string);
    return $string;
} 

//Check to see if a message was sent.
if(isset($_POST['message']) && $_POST['message'] != '') {
		$message = str_replace("\n", " ", $_POST['message']);
		$message = preg_replace("/^(.{255}).*$/", "$1", $message);
		$message = trim(stripinput(censorwords($message)));
	    $message = bigword($message);
	$sql = "INSERT INTO ".DB_MESSAGE."(chat_id, user_id, user_name, message, post_time) VALUES (" .$_GET['chat'] . ", 1, '" . $_POST['name'] . 
			"', '" . $message . "', ".time().")";
	dbquery($sql);
}
//Check to see if a reset request was sent.
if(isset($_POST['action']) && $_POST['action'] == 'reset') {
	$sql = "DELETE FROM ".DB_MESSAGE." WHERE chat_id = " . $_GET['chat'];
	dbquery($sql);
}

//Create the XML response.
$xml = '<?xml version="1.0" ?><root>';
//Check to ensure the user is in a chat room.
if(!isset($_GET['chat'])) {
	$xml .='Your are not currently in a chat session.  <a href="">Enter a chat session here</a>';
	$xml .= '<message id="0">';
	$xml .= '<user>Admin</user>';
	$xml .= '<text>Your are not currently in a chat session.  &lt;a href=""&gt;Enter a chat session here&lt;/a&gt;</text>';
	$xml .= '<time>' . date('h:i') . '</time>';
	$xml .= '</message>';
} else {
	$last = (isset($_GET['last']) && $_GET['last'] != '') ? $_GET['last'] : 0;
	$sql = "SELECT message_id, user_name, message, post_time" . 
		" FROM ".DB_MESSAGE." WHERE chat_id = " . $_GET['chat'] . " AND message_id > " . $last;
	$message_query = dbquery($sql);
	//Loop through each message and create an XML message node for each.
	while($message_array = dbarray($message_query)) {
		$xml .= '<message id="' . $message_array['message_id'] . '">';
		$xml .= '<user>' . htmlspecialchars($message_array['user_name']) . '</user>';
		$xml .= '<text>' . htmlspecialchars($message_array['message']) . '</text>';
		$xml .= '<time>' . showdate("shortdate", $message_array['post_time']) . '</time>';
		$xml .= '</message>';
	}
}
$xml .= '</root>';
echo $xml;
?>